diff --git a/package/boot/uboot-envtools/files/ramips b/package/boot/uboot-envtools/files/ramips
index f992f41bc8..6b539ef6d8 100644
--- a/package/boot/uboot-envtools/files/ramips
+++ b/package/boot/uboot-envtools/files/ramips
@@ -17,7 +17,6 @@ alfa-network,ac1200rm|\
 alfa-network,awusfree1)
 	ubootenv_add_uci_config "/dev/mtd1" "0x0" "0x1000" "0x1000"
 	;;
-all0239-3g|\
 all0256n-4M|\
 all0256n-8M|\
 all5002)
diff --git a/target/linux/ramips/base-files/etc/board.d/02_network b/target/linux/ramips/base-files/etc/board.d/02_network
index d07a6f2193..64d21ed7f8 100755
--- a/target/linux/ramips/base-files/etc/board.d/02_network
+++ b/target/linux/ramips/base-files/etc/board.d/02_network
@@ -434,7 +434,6 @@ ramips_setup_macs()
 	wmdr-143n)
 		lan_mac=$(cat /sys/class/net/eth0/address)
 		;;
-	all0239-3g|\
 	carambola|\
 	freestation5|\
 	w502u|\
diff --git a/target/linux/ramips/base-files/lib/ramips.sh b/target/linux/ramips/base-files/lib/ramips.sh
index 307ab35c3c..ca71ef3b84 100755
--- a/target/linux/ramips/base-files/lib/ramips.sh
+++ b/target/linux/ramips/base-files/lib/ramips.sh
@@ -34,9 +34,6 @@ ramips_board_detect() {
 	*"Air3GII")
 		name="air3gii"
 		;;
-	*"ALL0239-3G")
-		name="all0239-3g"
-		;;
 	*"ALL0256N (4M)")
 		name="all0256n-4M"
 		;;
@@ -586,9 +583,6 @@ ramips_board_detect() {
 	*"WL-330N3G")
 		name="wl-330n3g"
 		;;
-	*"WL-341 v3")
-		name="wl-341v3"
-		;;
 	*"WL-351 v1 002")
 		name="wl-351"
 		;;
diff --git a/target/linux/ramips/base-files/lib/upgrade/platform.sh b/target/linux/ramips/base-files/lib/upgrade/platform.sh
index 684ce1632e..31c37dfa17 100755
--- a/target/linux/ramips/base-files/lib/upgrade/platform.sh
+++ b/target/linux/ramips/base-files/lib/upgrade/platform.sh
@@ -18,7 +18,6 @@ platform_check_image() {
 	air3gii|\
 	alfa-network,ac1200rm|\
 	alfa-network,awusfree1|\
-	all0239-3g|\
 	all0256n-4M|\
 	all0256n-8M|\
 	all5002|\
@@ -194,7 +193,6 @@ platform_check_image() {
 	wizfi630a|\
 	wl-330n|\
 	wl-330n3g|\
-	wl-341v3|\
 	wl-351|\
 	wl-wn575a3|\
 	wli-tx4-ag300n|\
diff --git a/target/linux/ramips/dts/ALL0239-3G.dts b/target/linux/ramips/dts/ALL0239-3G.dts
deleted file mode 100644
index 9d25c599c0..0000000000
--- a/target/linux/ramips/dts/ALL0239-3G.dts
+++ /dev/null
@@ -1,131 +0,0 @@
-/dts-v1/;
-
-#include "rt3050.dtsi"
-
-#include <dt-bindings/gpio/gpio.h>
-#include <dt-bindings/input/input.h>
-
-/ {
-	compatible = "allnet,all0239-3g", "ralink,rt3052-soc";
-	model = "Allnet ALL0239-3G";
-
-	aliases {
-		led-boot = &led_status;
-		led-failsafe = &led_status;
-		led-running = &led_status;
-		led-upgrade = &led_status;
-	};
-
-
-	cfi@1f000000 {
-		compatible = "cfi-flash";
-		reg = <0x1f000000 0x800000>;
-		bank-width = <2>;
-		device-width = <2>;
-
-		partitions {
-			compatible = "fixed-partitions";
-			#address-cells = <1>;
-			#size-cells = <1>;
-
-			partition@0 {
-				label = "u-boot";
-				reg = <0x0 0x30000>;
-				read-only;
-			};
-
-			partition@30000 {
-				label = "u-boot-env";
-				reg = <0x30000 0x10000>;
-				read-only;
-			};
-
-			factory: partition@40000 {
-				label = "factory";
-				reg = <0x40000 0x10000>;
-				read-only;
-			};
-
-			partition@50000 {
-				compatible = "denx,uimage";
-				label = "firmware";
-				reg = <0x50000 0x7b0000>;
-			};
-		};
-	};
-
-	gpio-leds {
-		compatible = "gpio-leds";
-
-		usb {
-			label = "all0239-3g:green:usb";
-			gpios = <&gpio0 8 GPIO_ACTIVE_LOW>;
-			trigger-sources = <&otg_port1>;
-			linux,default-trigger = "usbport";
-		};
-
-		3g {
-			label = "all0239-3g:green:3g";
-			gpios = <&gpio0 11 GPIO_ACTIVE_LOW>;
-		};
-
-		led_status: status {
-			label = "all0239-3g:green:status";
-			gpios = <&gpio0 12 GPIO_ACTIVE_LOW>;
-		};
-
-		wps {
-			label = "all0239-3g:green:wps";
-			gpios = <&gpio0 14 GPIO_ACTIVE_LOW>;
-		};
-	};
-
-	gpio-keys-polled {
-		compatible = "gpio-keys-polled";
-		poll-interval = <20>;
-
-		reset {
-			label = "reset";
-			gpios = <&gpio0 10 GPIO_ACTIVE_LOW>;
-			linux,code = <KEY_RESTART>;
-		};
-
-		connect {
-			label = "connect";
-			gpios = <&gpio0 7 GPIO_ACTIVE_LOW>;
-			linux,code = <KEY_CONNECT>;
-		};
-
-		wps {
-			label = "wps";
-			gpios = <&gpio0 0 GPIO_ACTIVE_LOW>;
-			linux,code = <KEY_WPS_BUTTON>;
-		};
-	};
-};
-
-&pinctrl {
-	state_default: pinctrl0 {
-		gpio {
-			ralink,group = "i2c", "jtag", "rgmii", "mdio", "uartf";
-			ralink,function = "gpio";
-		};
-	};
-};
-
-&ethernet {
-	mtd-mac-address = <&factory 0x28>;
-};
-
-&esw {
-	status = "okay";
-	mediatek,portmap = <0x3e>;
-};
-
-&wmac {
-	ralink,mtd-eeprom = <&factory 0>;
-};
-
-&otg {
-	status = "okay";
-};
diff --git a/target/linux/ramips/dts/WL-341V3.dts b/target/linux/ramips/dts/WL-341V3.dts
deleted file mode 100644
index 955db0f56b..0000000000
--- a/target/linux/ramips/dts/WL-341V3.dts
+++ /dev/null
@@ -1,129 +0,0 @@
-/dts-v1/;
-
-#include "rt3050.dtsi"
-
-#include <dt-bindings/gpio/gpio.h>
-#include <dt-bindings/input/input.h>
-
-/ {
-	compatible = "sitecom,wl-341-v3", "ralink,rt3052-soc";
-	model = "Sitecom WL-341 v3";
-
-	cfi@1f000000 {
-		compatible = "cfi-flash";
-		reg = <0x1f000000 0x800000>;
-		bank-width = <2>;
-		device-width = <2>;
-
-		partitions {
-			compatible = "fixed-partitions";
-			#address-cells = <1>;
-			#size-cells = <1>;
-
-			partition@0 {
-				label = "u-boot";
-				reg = <0x0 0x20000>;
-				read-only;
-			};
-
-			boardnvram: partition@20000 {
-				label = "board-nvram";
-				reg = <0x20000 0x10000>;
-				read-only;
-			};
-
-			partition@30000 {
-				label = "u-boot-env";
-				reg = <0x30000 0x10000>;
-				read-only;
-			};
-
-			partition@40000 {
-				compatible = "denx,uimage";
-				label = "firmware";
-				reg = <0x40000 0x3b0000>;
-			};
-		};
-	};
-
-	gpio-leds {
-		compatible = "gpio-leds";
-
-		first {
-			label = "wl-341v3:amber:first";
-			gpios = <&gpio0 9 GPIO_ACTIVE_LOW>;
-		};
-
-		first2 {
-			label = "wl-341v3:blue:first";
-			gpios = <&gpio0 13 GPIO_ACTIVE_LOW>;
-		};
-
-		third {
-			label = "wl-341v3:amber:third";
-			gpios = <&gpio0 11 GPIO_ACTIVE_LOW>;
-		};
-
-		third2 {
-			label = "wl-341v3:blue:third";
-			gpios = <&gpio0 14 GPIO_ACTIVE_LOW>;
-		};
-
-		fourth {
-			label = "wl-341v3:blue:fourth";
-			gpios = <&gpio0 10 GPIO_ACTIVE_LOW>;
-		};
-
-		fifth {
-			label = "wl-341v3:amber:fifth";
-			gpios = <&gpio0 12 GPIO_ACTIVE_LOW>;
-		};
-
-		fifth2 {
-			label = "wl-341v3:blue:fifth";
-			gpios = <&gpio0 8 GPIO_ACTIVE_LOW>;
-		};
-	};
-
-	gpio-keys-polled {
-		compatible = "gpio-keys-polled";
-		poll-interval = <20>;
-
-		reset {
-			label = "reset";
-			gpios = <&gpio0 7 GPIO_ACTIVE_LOW>;
-			linux,code = <KEY_RESTART>;
-		};
-
-		wps {
-			label = "wps";
-			gpios = <&gpio0 5 GPIO_ACTIVE_LOW>;
-			linux,code = <KEY_WPS_BUTTON>;
-		};
-	};
-};
-
-&pinctrl {
-	state_default: pinctrl0 {
-		gpio {
-			ralink,group = "i2c", "jtag", "rgmii", "mdio", "uartf";
-			ralink,function = "gpio";
-		};
-	};
-};
-
-&ethernet {
-	mtd-mac-address = <&boardnvram 0xffa0>;
-};
-
-&esw {
-	mediatek,portmap = <0x3e>;
-};
-
-&wmac {
-	ralink,mtd-eeprom = <&boardnvram 0xfd70>;
-};
-
-&otg {
-	status = "okay";
-};
diff --git a/target/linux/ramips/image/Makefile b/target/linux/ramips/image/Makefile
index b4ff9a7492..5718558e91 100644
--- a/target/linux/ramips/image/Makefile
+++ b/target/linux/ramips/image/Makefile
@@ -7,21 +7,6 @@
 include $(TOPDIR)/rules.mk
 include $(INCLUDE_DIR)/image.mk
 
-define imgname
-$(BIN_DIR)/$(IMG_PREFIX)-$(2)-$(1)
-endef
-
-define sysupname
-$(call imgname,$(1),$(2))-sysupgrade.bin
-endef
-
-VMLINUX:=$(IMG_PREFIX)-vmlinux
-UIMAGE:=$(IMG_PREFIX)-uImage
-
-define Image/Build/Initramfs
-	$(call Image/Build/Profile/$(PROFILE),initramfs)
-endef
-
 DEVICE_VARS += DTS IMAGE_SIZE NETGEAR_BOARD_ID NETGEAR_HW_ID
 DEVICE_VARS += BUFFALO_TAG_PLATFORM BUFFALO_TAG_VERSION BUFFALO_TAG_MINOR
 
@@ -86,18 +71,6 @@ define Build/relocate-kernel
 	rm -rf $@.relocate
 endef
 
-define MkCombineduImage
-	$(call PatchKernelLzma,$(2),$(3))
-	if [ `stat -c%s "$(KDIR)/vmlinux-$(2).bin.lzma"` -gt `expr $(4) - 64` ]; then \
-		echo "Warning: $(KDIR)/vmlinux-$(2).bin.lzma is too big" >&2; \
-	else if [ `stat -c%s "$(KDIR)/root.$(1)"` -gt $(5) ]; then \
-		echo "Warning: $(KDIR)/root.$(1) is too big" >&2; \
-	else \
-		( dd if=$(KDIR)/vmlinux-$(2).bin.lzma bs=`expr $(4) - 64` conv=sync ; dd if=$(KDIR)/root.$(1) ) > $(KDIR)/vmlinux-$(2).bin.lzma.combined ; \
-	fi ; fi
-	$(call MkImage,lzma,$(KDIR)/vmlinux-$(2).bin.lzma.combined,$(call sysupname,$(1),$(2)),$(6))
-endef
-
 define Build/umedia-header
 	fix-u-media-header -T 0x46 -B $(1) -i $@ -o $@.new && mv $@.new $@
 endef
@@ -150,93 +123,17 @@ define Build/zyimage
 	$(STAGING_DIR_HOST)/bin/zyimage $(1) $@
 endef
 
-#
-# The real magic happens inside these templates
-#
-# $(1), compression method
-# $(2), filename of image data
-# $(3), output filename
-define MkImage
-	$(eval imagename=$(if $(4),$(4),MIPS $(VERSION_DIST) Linux-$(LINUX_VERSION)))
-	-mkimage -A mips -O linux -T kernel -C $(1) -a $(loadaddr-y) -e $(loadaddr-y) \
-		-n "$(imagename)" \
-		-d $(2) $(3)
-endef
-
-define CompressLzma
-	$(STAGING_DIR_HOST)/bin/lzma e $(1) -lc1 -lp2 -pb2 $(2)
-endef
-
-define MkImageSysupgrade/squashfs
-	$(eval output_name=$(IMG_PREFIX)-$(2)-$(1)-$(if $(4),$(4),sysupgrade).bin)
-	cat $(KDIR)/vmlinux-$(2).uImage $(KDIR)/root.$(1) > $(KDIR)/$(output_name)
-	$(call prepare_generic_squashfs,$(KDIR)/$(output_name))
-	if [ `stat -c%s "$(KDIR)/$(output_name)"` -gt $(3) ]; then \
-		echo "Warning: $(KDIR)/$(output_name) is too big" >&2; \
-	else \
-		$(CP) $(KDIR)/$(output_name) $(BIN_DIR)/$(output_name); \
-	fi
-endef
-
-# $(1), lowercase board name like "mt7620a_v22sg"
-# $(2), DTS filename without .dts extension
-# $(3), optional filename suffix, e.g. "-initramfs"
-define PatchKernelLzmaDtb
-	cp $(KDIR)/vmlinux$(3) $(KDIR)/vmlinux-$(1)$(3)
-	$(call Image/BuildDTB,../dts/$(2).dts,$(KDIR)/$(2).dtb)
-	$(STAGING_DIR_HOST)/bin/patch-dtb $(KDIR)/vmlinux-$(1)$(3) $(KDIR)/$(2).dtb
-	$(call CompressLzma,$(KDIR)/vmlinux-$(1)$(3),$(KDIR)/vmlinux-$(1)$(3).bin.lzma)
-endef
-
-# $(1), lowercase board name
-# $(2), DTS filename without .dts extension
-# $(3), ih_name field of uImage header
-# $(4), optional filename suffix, e.g. "-initramfs"
-define MkImageLzmaDtb
-	$(call PatchKernelLzmaDtb,$(1),$(2),$(4))
-	$(call MkImage,lzma,$(KDIR)/vmlinux-$(1)$(4).bin.lzma,$(KDIR)/vmlinux-$(1)$(4).uImage,$(3))
-endef
-
-# $(1), Rootfs type, e.g. squashfs
-# $(2), lowercase board name
-# $(3), DTS filename without .dts extension
-# $(4), maximum size of sysupgrade image
-# $(5), uImage header's ih_name field
-define BuildFirmware/OF
-	$(call MkImageLzmaDtb,$(2),$(3),$(5))
-	$(call MkImageSysupgrade/$(1),$(1),$(2),$(4),$(6))
-endef
-
-# $(1), squashfs/initramfs
-# $(2), lowercase board name
-# $(3), DTS filename without .dts extension
-# $(4), ih_name field of uImage header
-define BuildFirmware/OF/initramfs
-	$(call MkImageLzmaDtb,$(2),$(3),$(4),-initramfs)
-	$(CP) $(KDIR)/vmlinux-$(2)-initramfs.uImage $(call imgname,$(1),$(2))-uImage.bin
-endef
-
-# Build images for default ralink layout for 4MB flash
-# kernel + roots = 0x3b0000
-# $(1) = squashfs/initramfs
-# $(2) = lowercase board name
-# $(3) = dts file
 ralink_default_fw_size_4M=3866624
-BuildFirmware/Default4M/squashfs=$(call BuildFirmware/OF,$(1),$(2),$(3),$(ralink_default_fw_size_4M),$(4))
-BuildFirmware/Default4M/initramfs=$(call BuildFirmware/OF/initramfs,$(1),$(2),$(3),$(4))
-
 ralink_default_fw_size_8M=8060928
 ralink_default_fw_size_16M=16121856
 ralink_default_fw_size_32M=33226752
 
-
 ifeq ($(SUBTARGET),rt288x)
 include rt288x.mk
 endif
 
 ifeq ($(SUBTARGET),rt305x)
 include rt305x.mk
-include rt305x-legacy.mk
 endif
 
 ifeq ($(SUBTARGET),rt3883)
@@ -255,37 +152,4 @@ ifeq ($(SUBTARGET),mt76x8)
 include mt76x8.mk
 endif
 
-ifdef LEGACY_DEVICES
-#
-# Generic Targets - only needed for legacy image building code
-#
-define Image/BuildKernel
-	cp $(KDIR)/vmlinux.elf $(BIN_DIR)/$(VMLINUX).elf
-	cp $(KDIR)/vmlinux $(BIN_DIR)/$(VMLINUX).bin
-	$(call CompressLzma,$(KDIR)/vmlinux,$(KDIR)/vmlinux.bin.lzma)
-	$(call MkImage,lzma,$(KDIR)/vmlinux.bin.lzma,$(KDIR)/uImage.lzma)
-	cp $(KDIR)/uImage.lzma $(BIN_DIR)/$(UIMAGE).bin
-endef
-
-define Image/BuildKernel/Initramfs
-	cp $(KDIR)/vmlinux-initramfs.elf $(BIN_DIR)/$(VMLINUX)-initramfs.elf
-	cp $(KDIR)/vmlinux-initramfs $(BIN_DIR)/$(VMLINUX)-initramfs.bin
-	$(call CompressLzma,$(KDIR)/vmlinux-initramfs,$(KDIR)/vmlinux-initramfs.bin.lzma)
-	$(call MkImage,lzma,$(KDIR)/vmlinux-initramfs.bin.lzma,$(KDIR)/uImage-initramfs.lzma)
-	cp $(KDIR)/uImage-initramfs.lzma $(BIN_DIR)/$(UIMAGE)-initramfs.bin
-	$(call Image/Build/Initramfs)
-endef
-
-define Image/Build
-	$(call Image/Build/$(1))
-	dd if=$(KDIR)/root.$(1) of=$(BIN_DIR)/$(IMG_PREFIX)-root.$(1) bs=128k conv=sync
-endef
-
-define Image/Build/Profile
-	$(if $(CONFIG_TARGET_ROOTFS_INITRAMFS),$(call Image/Build/Profile/$(1),initramfs))
-	$(call Image/Build/Profile/$(1),$(2))
-endef
-
-endif
-
 $(eval $(call BuildImage))
diff --git a/target/linux/ramips/image/rt305x-legacy.mk b/target/linux/ramips/image/rt305x-legacy.mk
deleted file mode 100644
index f5a892d365..0000000000
--- a/target/linux/ramips/image/rt305x-legacy.mk
+++ /dev/null
@@ -1,43 +0,0 @@
-#
-# RT305X Profiles
-#
-kernel_size_wl341v3=917504
-rootfs_size_wl341v3=2949120
-define BuildFirmware/WL-341V3/squashfs
-	$(call BuildFirmware/Default4M/$(1),$(1),wl-341v3,WL-341V3)
-	# This code looks broken and really needs to be converted to C
-	if [ -e "$(call sysupname,$(1),$(2))" ]; then \
-		( \
-			dd if=/dev/zero bs=195936 count=1; \
-			echo "1.01"; \
-			dd if=/dev/zero bs=581 count=1; \
-			echo -n -e "\x73\x45\x72\x43\x6F\x4D\x6D\x00\x01\x00\x00\x59\x4E\x37\x95\x58\x10\x00\x20\x00\x28\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x11\x03\x00\x00\x80\x00\x00\x00\x00\x03\x00\x00\x10\x12\x00\x00\x00\x10\x73\x45\x72\x43\x6F\x4D\x6D"; \
-			dd if=/dev/zero bs=65552 count=1; \
-			dd if=$(KDIR)/vmlinux-$(2).uImage bs=$(kernel_size_wl341v3) conv=sync; \
-			dd if=$(KDIR)/root.$(1) bs=64k conv=sync; \
-			dd if=/dev/zero bs=`expr 4194304 - 262144 - 16 - $(kernel_size_wl341v3) - \( \( \( \`stat -c%s $(KDIR)/root.$(1)\` / 65536 \) + 1 \) \* 65536 \)` count=1; \
-			echo -n -e "\x11\x03\x80\x00\x10\x12\x90\xF7\x65\x52\x63\x4F\x6D\x4D\x00\x00"; \
-		) > $(call imgname,$(1),$(2))-factory.bin; \
-	fi
-endef
-BuildFirmware/WL-341V3/initramfs=$(call BuildFirmware/OF/initramfs,$(1),wl-341v3,WL-341V3)
-
-define BuildFirmware/UIMAGE_8M
-	$(call MkCombineduImage,$(1),$(2),$(call mkcmdline,$(3),$(4),$(5)) $(call mkmtd/$(6),$(mtdlayout_8M)),$(kernel_size_8M),$(rootfs_size_8M),$(7))
-endef
-define Image/Build/Profile/ALL02393G
-	$(call Image/Build/Template/$(image_type)/$(1),UIMAGE_8M,all0239-3g,ALL0239-3G,ttyS1,57600,phys)
-endef
-
-Image/Build/Profile/WL-341V3=$(call BuildFirmware/WL-341V3/$(1),$(1))
-
-define LegacyDevice/ALL02393G
-  DEVICE_TITLE := Allnet ALL0239-3G 
-  DEVICE_PACKAGES := kmod-usb-core kmod-usb-dwc2 kmod-usb-ledtrig-usbport
-endef
-LEGACY_DEVICES += ALL02393G
-
-define LegacyDevice/WL-341V3
-  DEVICE_TITLE := Sitecom WL-341 v3
-endef
-LEGACY_DEVICES += WL-341V3